diff -r f40675df5d4c trytond/modules/account/tax.py
--- a/trytond/modules/account/tax.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/tax.py	Mon Sep 24 20:36:38 2012 +0200
@@ -6,35 +6,37 @@
 from trytond.backend import TableHandler
 from trytond.pyson import Eval, If, Bool, PYSONEncoder
 from trytond.transaction import Transaction
-from trytond.cache import Cache
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.config import CONFIG
 
+__all__ = ['TaxGroup', 'TaxCodeTemplate', 'TaxCode',
+    'OpenChartTaxCodeStart', 'OpenChartTaxCode',
+    'TaxTemplate', 'Tax', 'TaxLine', 'TaxRuleTemplate', 'TaxRule',
+    'TaxRuleLineTemplate', 'TaxRuleLine',
+    'OpenTaxCode',
+    'AccountTemplateTaxTemplate', 'AccountTemplate2', 'AccountTax', 'Account2']
+__metaclass__ = PoolMeta
 
-class Group(ModelSQL, ModelView):
+
+class TaxGroup(ModelSQL, ModelView):
     'Tax Group'
-    _name = 'account.tax.group'
-    _description = __doc__
-
+    __name__ = 'account.tax.group'
     name = fields.Char('Name', size=None, required=True, translate=True)
     code = fields.Char('Code', size=None, required=True)
 
-    def init(self, module_name):
-        super(Group, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(TaxGroup, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.4 drop code_uniq constraint
         table.drop_constraint('code_uniq')
 
-Group()
 
-
-class CodeTemplate(ModelSQL, ModelView):
+class TaxCodeTemplate(ModelSQL, ModelView):
     'Tax Code Template'
-    _name = 'account.tax.code.template'
-    _description = __doc__
-
+    __name__ = 'account.tax.code.template'
     name = fields.Char('Name', required=True, translate=True)
     code = fields.Char('Code')
     parent = fields.Many2One('account.tax.code.template', 'Parent')
@@ -43,104 +45,88 @@
             domain=[('parent', '=', None)], required=True)
     description = fields.Text('Description', translate=True)
 
-    def __init__(self):
-        super(CodeTemplate, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(TaxCodeTemplate, cls).__setup__()
+        cls._constraints += [
             ('check_recursion', 'recursive_tax_code'),
-        ]
-        self._error_messages.update({
-            'recursive_tax_code': 'You can not create recursive tax codes!',
-        })
-        self._order.insert(0, ('code', 'ASC'))
-        self._order.insert(0, ('account', 'ASC'))
+            ]
+        cls._error_messages.update({
+                'recursive_tax_code': \
+                    'You can not create recursive tax codes!',
+                })
+        cls._order.insert(0, ('code', 'ASC'))
+        cls._order.insert(0, ('account', 'ASC'))
 
-    def _get_tax_code_value(self, template, code=None):
+    def _get_tax_code_value(self, code=None):
         '''
         Set values for tax code creation.
-
-        :param template: the BrowseRecord of the template
-        :param code: the BrowseRecord of the code to update
-        :return: a dictionary with tax code fields as key and values as value
         '''
         res = {}
-        if not code or code.name != template.name:
-            res['name'] = template.name
-        if not code or code.code != template.code:
-            res['code'] = template.code
-        if not code or code.description != template.description:
-            res['description'] = template.description
-        if not code or code.template.id != template.id:
-            res['template'] = template.id
+        if not code or code.name != self.name:
+            res['name'] = self.name
+        if not code or code.code != self.code:
+            res['code'] = self.code
+        if not code or code.description != self.description:
+            res['description'] = self.description
+        if not code or code.template.id != self.id:
+            res['self'] = self.id
         return res
 
-    def create_tax_code(self, template, company_id, template2tax_code=None,
+    def create_tax_code(self, company_id, template2tax_code=None,
             parent_id=None):
         '''
         Create recursively tax codes based on template.
-
-        :param template: the template id or the BrowseRecord of template
-                used for tax code creation
-        :param company_id: the id of the company for which tax codes are
-                created
-        :param template2tax_code: a dictionary with tax code template id as key
-                and tax code id as value, used to convert template id into
-                tax code. The dictionary is filled with new tax codes
-        :param parent_id: the tax code id of the parent of the tax codes that
-                must be created
-        :return: id of the tax code created
+        template2tax_code is a dictionary with tax code template id as key and
+        tax code id as value, used to convert template id into tax code. The
+        dictionary is filled with new tax codes.
+        Return the id of the tax code created
         '''
-        tax_code_obj = Pool().get('account.tax.code')
-        lang_obj = Pool().get('ir.lang')
+        pool = Pool()
+        TaxCode = pool.get('account.tax.code')
+        Lang = pool.get('ir.lang')
 
         if template2tax_code is None:
             template2tax_code = {}
 
-        if isinstance(template, (int, long)):
-            template = self.browse(template)
-
-        if template.id not in template2tax_code:
-            vals = self._get_tax_code_value(template)
+        if self.id not in template2tax_code:
+            vals = self._get_tax_code_value()
             vals['company'] = company_id
             vals['parent'] = parent_id
 
-            new_id = tax_code_obj.create(vals)
+            new_tax_code = TaxCode.create(vals)
 
-            prev_lang = template._context.get('language') or CONFIG['language']
+            prev_lang = self._context.get('language') or CONFIG['language']
             prev_data = {}
-            for field_name, field in template._columns.iteritems():
+            for field_name, field in self._fields.iteritems():
                 if getattr(field, 'translate', False):
-                    prev_data[field_name] = template[field_name]
-            for lang in lang_obj.get_translatable_languages():
+                    prev_data[field_name] = getattr(self, field_name)
+            for lang in Lang.get_translatable_languages():
                 if lang == prev_lang:
                     continue
-                template.setLang(lang)
-                data = {}
-                for field_name, field in template._columns.iteritems():
-                    if getattr(field, 'translate', False) \
-                            and template[field_name] != prev_data[field_name]:
-                        data[field_name] = template[field_name]
-                if data:
-                    with Transaction().set_context(language=lang):
-                        tax_code_obj.write(new_id, data)
-            template.setLang(prev_lang)
-            template2tax_code[template.id] = new_id
-        else:
-            new_id = template2tax_code[template.id]
+                with Transaction().set_context(language=lang):
+                    template = self.__class__(self.id)
+                    data = {}
+                    for field_name, field in template._fields.iteritems():
+                        if (getattr(field, 'translate', False)
+                                and (getattr(template, field_name) !=
+                                    prev_data[field_name])):
+                            data[field_name] = getattr(template, field_name)
+                    if data:
+                        TaxCode.write([new_tax_code], data)
+            template2tax_code[self.id] = new_tax_code.id
+        new_id = template2tax_code[self.id]
 
         new_childs = []
         for child in template.childs:
-            new_childs.append(self.create_tax_code(child, company_id,
-                template2tax_code=template2tax_code, parent_id=new_id))
+            new_childs.append(child.create_tax_code(company_id,
+                    template2tax_code=template2tax_code, parent_id=new_id))
         return new_id
 
-CodeTemplate()
 
-
-class Code(ModelSQL, ModelView):
+class TaxCode(ModelSQL, ModelView):
     'Tax Code'
-    _name = 'account.tax.code'
-    _description = __doc__
-
+    __name__ = 'account.tax.code'
     name = fields.Char('Name', size=None, required=True, select=True,
                        translate=True)
     code = fields.Char('Code', size=None, select=True)
@@ -152,51 +138,50 @@
     childs = fields.One2Many('account.tax.code', 'parent', 'Children',
             domain=[('company', '=', Eval('company', 0))], depends=['company'])
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['company']), 'get_currency_digits')
+        on_change_with=['company']), 'on_change_with_currency_digits')
     sum = fields.Function(fields.Numeric('Sum',
         digits=(16, Eval('currency_digits', 2)), depends=['currency_digits']),
         'get_sum')
     template = fields.Many2One('account.tax.code.template', 'Template')
     description = fields.Text('Description', translate=True)
 
-    def __init__(self):
-        super(Code, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(TaxCode, cls).__setup__()
+        cls._constraints += [
             ('check_recursion', 'recursive_tax_code'),
-        ]
-        self._error_messages.update({
-            'recursive_tax_code': 'You can not create recursive tax codes!',
-        })
-        self._order.insert(0, ('code', 'ASC'))
+            ]
+        cls._error_messages.update({
+                'recursive_tax_code': \
+                    'You can not create recursive tax codes!',
+                })
+        cls._order.insert(0, ('code', 'ASC'))
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def on_change_with_currency_digits(self, vals):
-        company_obj = Pool().get('company.company')
-        if vals.get('company'):
-            company = company_obj.browse(vals['company'])
-            return company.currency.digits
+    def on_change_with_currency_digits(self, name=None):
+        if self.company:
+            return self.company.currency.digits
         return 2
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for code in self.browse(ids):
-            res[code.id] = code.company.currency.digits
-        return res
-
-    def get_sum(self, ids, name):
+    @classmethod
+    def get_sum(cls, codes, name):
         cursor = Transaction().cursor
         res = {}
-        move_line_obj = Pool().get('account.move.line')
-        currency_obj = Pool().get('currency.currency')
+        pool = Pool()
+        MoveLine = pool.get('account.move.line')
 
-        child_ids = self.search([('parent', 'child_of', ids)])
-        all_ids = {}.fromkeys(ids + child_ids).keys()
-        line_query, _ = move_line_obj.query_get()
+        childs = cls.search([
+                ('parent', 'child_of', [c.id for c in codes]),
+                ])
+        all_codes = list(set(codes) | set(childs))
+        line_query, _ = MoveLine.query_get()
         cursor.execute('SELECT c.id, SUM(tl.amount) '
             'FROM account_tax_code c, '
                 'account_tax_line tl, '
@@ -204,10 +189,10 @@
             'WHERE c.id = tl.code '
                 'AND tl.move_line = l.id '
                 'AND c.id IN (' +
-                    ','.join(('%s',) * len(all_ids)) + ') '
+                    ','.join(('%s',) * len(all_codes)) + ') '
                 'AND ' + line_query + ' '
                 'AND c.active '
-            'GROUP BY c.id', all_ids)
+            'GROUP BY c.id', [c.id for c in all_codes])
         code_sum = {}
         for code_id, sum in cursor.fetchall():
             # SQLite uses float for SUM
@@ -215,97 +200,82 @@
                 sum = Decimal(str(sum))
             code_sum[code_id] = sum
 
-        for code in self.browse(ids):
+        for code in codes:
             res.setdefault(code.id, Decimal('0.0'))
-            child_ids = self.search([
-                ('parent', 'child_of', [code.id]),
-                ])
-            for child_id in child_ids:
-                res[code.id] += currency_obj.round(code.company.currency,
-                        code_sum.get(child_id, Decimal('0.0')))
-            res[code.id] = currency_obj.round(code.company.currency,
-                    res[code.id])
+            childs = cls.search([
+                    ('parent', 'child_of', [code.id]),
+                    ])
+            for child in childs:
+                res[code.id] += code.company.currency.round(
+                    code_sum.get(child.id, Decimal('0.0')))
+            res[code.id] = code.company.currency.round(res[code.id])
         return res
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
-        for code in self.browse(ids):
-            if code.code:
-                res[code.id] = code.code + ' - ' + code.name
-            else:
-                res[code.id] = code.name
-        return res
+    def get_rec_name(self, name):
+        if self.code:
+            return self.code + ' - ' + self.name
+        else:
+            return self.name
 
-    def search_rec_name(self, name, clause):
-        ids = self.search([('code',) + tuple(clause[1:])], limit=1, order=[])
-        if ids:
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        codes = cls.search([('code',) + tuple(clause[1:])], limit=1, order=[])
+        if codes:
             return [('code',) + tuple(clause[1:])]
         return [('name',) + tuple(clause[1:])]
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        code_ids = self.search([
-            ('parent', 'child_of', ids),
-            ])
-        return super(Code, self).delete(code_ids)
+    @classmethod
+    def delete(cls, codes):
+        codes = cls.search([
+                ('parent', 'child_of', [c.id for c in codes]),
+                ])
+        super(TaxCode, cls).delete(codes)
 
-    def update_tax_code(self, code, template2tax_code=None):
+    def update_tax_code(self, template2tax_code=None):
         '''
         Update recursively tax code based on template.
-
-        :param code: a code id or the BrowseRecord of the code
-        :param template2tax_code: a dictionary with tax code template id as key
-                and tax code id as value, used to convert template id into
-                tax code. The dictionary is filled with new tax codes
+        template2tax_code is a dictionary with tax code template id as key and
+        tax code id as value, used to convert template id into tax code. The
+        dictionary is filled with new tax codes
         '''
-        template_obj = Pool().get('account.tax.code.template')
-        lang_obj = Pool().get('ir.lang')
+        Lang = Pool().get('ir.lang')
 
         if template2tax_code is None:
             template2tax_code = {}
 
-        if isinstance(code, (int, long)):
-            code = self.browse(code)
+        if self.template:
+            vals = self.template._get_tax_code_value(code=self)
+            if vals:
+                self.write([self], vals)
 
-        if code.template:
-            vals = template_obj._get_tax_code_value(code.template, code=code)
-            if vals:
-                self.write(code.id, vals)
-
-            prev_lang = code._context.get('language') or CONFIG['language']
+            prev_lang = self._context.get('language') or CONFIG['language']
             prev_data = {}
-            for field_name, field in code.template._columns.iteritems():
+            for field_name, field in self.template._fields.iteritems():
                 if getattr(field, 'translate', False):
-                    prev_data[field_name] = code.template[field_name]
-            for lang in lang_obj.get_translatable_languages():
+                    prev_data[field_name] = getattr(self.template, field_name)
+            for lang in Lang.get_translatable_languages():
                 if lang == prev_lang:
                     continue
-                code.setLang(lang)
-                data = {}
-                for field_name, field in code.template._columns.iteritems():
-                    if (getattr(field, 'translate', False)
-                            and code.template[field_name] !=
-                            prev_data[field_name]):
-                        data[field_name] = code.template[field_name]
-                if data:
-                    with Transaction().set_context(language=lang):
-                        self.write(code.id, data)
-            code.setLang(prev_lang)
-            template2tax_code[code.template.id] = code.id
+                with Transaction().set_context(language=lang):
+                    code = self.__class__(self.id)
+                    data = {}
+                    for field_name, field in code.template._fields.iteritems():
+                        if (getattr(field, 'translate', False)
+                                and (getattr(code.template, field_name) !=
+                                    prev_data[field_name])):
+                            data[field_name] = getattr(code.template,
+                                field_name)
+                    if data:
+                        self.write([code], data)
+            template2tax_code[self.template.id] = self.id
 
         for child in code.childs:
-            self.update_tax_code(child, template2tax_code=template2tax_code)
-
-Code()
+            child.update_tax_code(template2tax_code=template2tax_code)
 
 
 class OpenChartTaxCodeStart(ModelView):
     'Open Chart of Tax Codes'
-    _name = 'account.tax.code.open_chart.start'
-    _description = __doc__
+    __name__ = 'account.tax.code.open_chart.start'
     method = fields.Selection([
         ('fiscalyear', 'By Fiscal Year'),
         ('periods', 'By Periods'),
@@ -321,16 +291,14 @@
             'invisible': Eval('method') != 'periods',
             }, depends=['method'])
 
-    def default_method(self):
+    @staticmethod
+    def default_method():
         return 'periods'
 
-OpenChartTaxCodeStart()
-
 
 class OpenChartTaxCode(Wizard):
     'Open Chart of Tax Codes'
-    _name = 'account.tax.code.open_chart'
-
+    __name__ = 'account.tax.code.open_chart'
     start = StateView('account.tax.code.open_chart.start',
         'account.tax_code_open_chart_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -338,28 +306,24 @@
             ])
     open_ = StateAction('account.act_tax_code_tree2')
 
-    def do_open_(self, session, action):
-        if session.start.method == 'fiscalyear':
+    def do_open_(self, action):
+        if self.start.method == 'fiscalyear':
             action['pyson_context'] = PYSONEncoder().encode({
-                    'fiscalyear': session.start.fiscalyear.id,
+                    'fiscalyear': self.start.fiscalyear.id,
                     })
         else:
             action['pyson_context'] = PYSONEncoder().encode({
-                    'periods': [x.id for x in session.start.periods],
+                    'periods': [x.id for x in self.start.periods],
                     })
         return action, {}
 
-    def transition_open_(self, session):
+    def transition_open_(self):
         return 'end'
 
-OpenChartTaxCode()
-
 
 class TaxTemplate(ModelSQL, ModelView):
     'Account Tax Template'
-    _name = 'account.tax.template'
-    _description = __doc__
-
+    __name__ = 'account.tax.template'
     name = fields.Char('Name', required=True, translate=True)
     description = fields.Char('Description', required=True, translate=True)
     group = fields.Many2One('account.tax.group', 'Group')
@@ -396,15 +360,17 @@
     account = fields.Many2One('account.account.template', 'Account Template',
             domain=[('parent', '=', None)], required=True)
 
-    def __init__(self):
-        super(TaxTemplate, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._order.insert(0, ('account', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(TaxTemplate, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._order.insert(0, ('account', 'ASC'))
 
-    def init(self, module_name):
-        super(TaxTemplate, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(TaxTemplate, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 group is no more required
         table.not_null_action('group', action='remove')
@@ -412,143 +378,134 @@
         #Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'percentage'
 
-    def default_include_base_amount(self):
+    @staticmethod
+    def default_include_base_amount():
         return False
 
-    def default_invoice_base_sign(self):
+    @staticmethod
+    def default_invoice_base_sign():
         return Decimal('1')
 
-    def default_invoice_tax_sign(self):
+    @staticmethod
+    def default_invoice_tax_sign():
         return Decimal('1')
 
-    def default_credit_note_base_sign(self):
+    @staticmethod
+    def default_credit_note_base_sign():
         return Decimal('1')
 
-    def default_credit_note_tax_sign(self):
+    @staticmethod
+    def default_credit_note_tax_sign():
         return Decimal('1')
 
-    def _get_tax_value(self, template, tax=None):
+    def _get_tax_value(self, tax=None):
         '''
         Set values for tax creation.
-
-        :param template: the BrowseRecord of the template
-        :param tax: the BrowseRecord of the tax to update
-        :return: a dictionary with account fields as key and values as value
         '''
         res = {}
         for field in ('name', 'description', 'sequence', 'amount',
                 'percentage', 'type', 'invoice_base_sign', 'invoice_tax_sign',
                 'credit_note_base_sign', 'credit_note_tax_sign'):
-            if not tax or tax[field] != template[field]:
-                res[field] = template[field]
+            if not tax or tax[field] != getattr(self, field):
+                res[field] = getattr(self, field)
         for field in ('group',):
-            if not tax or tax[field].id != template[field].id:
-                res[field] = template[field].id
-        if not tax or tax.template.id != template.id:
-            res['template'] = template.id
+            if not tax or tax[field].id != getattr(self, field).id:
+                res[field] = getattr(self, field).id
+        if not tax or tax.template.id != self.id:
+            res['template'] = self.id
         return res
 
-    def create_tax(self, template, company_id, template2tax_code,
-            template2account, template2tax=None, parent_id=None):
+    def create_tax(self, company_id, template2tax_code, template2account,
+            template2tax=None, parent_id=None):
         '''
         Create recursively taxes based on template.
 
-        :param template: the template id or the BrowseRecord of template
-                used for tax creation
-        :param company_id: the id of the company for which taxes are created
-        :param template2tax_code: a dictionary with tax code template id as key
-                and tax code id as value, used to convert tax code template
-                into tax code
-        :param template2account: a dictionary with account template id as key
-                and account id as value, used to convert account template into
-                account code
-        :param template2tax: a dictionary with tax template id as key and
-                tax id as value, used to convert template id into tax.
-                The dictionary is filled with new taxes
-        :param parent_id: the tax id of the parent of the tax that must be
-                created
-        :return: id of the tax created
+        template2tax_code is a dictionary with tax code template id as key and
+        tax code id as value, used to convert tax code template into tax code.
+        template2account is a dictionary with account template id as key and
+        account id as value, used to convert account template into account
+        code.
+        template2tax is a dictionary with tax template id as key and tax id as
+        value, used to convert template id into tax.  The dictionary is filled
+        with new taxes.
+        Return id of the tax created
         '''
-        tax_obj = Pool().get('account.tax')
-        lang_obj = Pool().get('ir.lang')
+        pool = Pool()
+        Tax = pool.get('account.tax')
+        Lang = pool.get('ir.lang')
 
         if template2tax is None:
             template2tax = {}
 
-        if isinstance(template, (int, long)):
-            template = self.browse(template)
-
-        if template.id not in template2tax:
-            vals = self._get_tax_value(template)
+        if self.id not in template2tax:
+            vals = self._get_tax_value()
             vals['company'] = company_id
             vals['parent'] = parent_id
-            if template.invoice_account:
+            if self.invoice_account:
                 vals['invoice_account'] = \
-                        template2account[template.invoice_account.id]
+                        template2account[self.invoice_account.id]
             else:
                 vals['invoice_account'] = None
-            if template.credit_note_account:
+            if self.credit_note_account:
                 vals['credit_note_account'] = \
-                        template2account[template.credit_note_account.id]
+                        template2account[self.credit_note_account.id]
             else:
                 vals['credit_note_account'] = None
-            if template.invoice_base_code:
+            if self.invoice_base_code:
                 vals['invoice_base_code'] = \
-                        template2tax_code[template.invoice_base_code.id]
+                        template2tax_code[self.invoice_base_code.id]
             else:
                 vals['invoice_base_code'] = None
-            if template.invoice_tax_code:
+            if self.invoice_tax_code:
                 vals['invoice_tax_code'] = \
-                        template2tax_code[template.invoice_tax_code.id]
+                        template2tax_code[self.invoice_tax_code.id]
             else:
                 vals['invoice_tax_code'] = None
-            if template.credit_note_base_code:
+            if self.credit_note_base_code:
                 vals['credit_note_base_code'] = \
-                        template2tax_code[template.credit_note_base_code.id]
+                        template2tax_code[self.credit_note_base_code.id]
             else:
                 vals['credit_note_base_code'] = None
-            if template.credit_note_tax_code:
+            if self.credit_note_tax_code:
                 vals['credit_note_tax_code'] = \
-                        template2tax_code[template.credit_note_tax_code.id]
+                        template2tax_code[self.credit_note_tax_code.id]
             else:
                 vals['credit_note_tax_code'] = None
 
-            new_id = tax_obj.create(vals)
+            new_tax = Tax.create(vals)
 
-            prev_lang = template._context.get('language') or CONFIG['language']
+            prev_lang = self._context.get('language') or CONFIG['language']
             prev_data = {}
-            for field_name, field in template._columns.iteritems():
+            for field_name, field in self._fields.iteritems():
                 if getattr(field, 'translate', False):
-                    prev_data[field_name] = template[field_name]
-            for lang in lang_obj.get_translatable_languages():
+                    prev_data[field_name] = getattr(self, field_name)
+            for lang in Lang.get_translatable_languages():
                 if lang == prev_lang:
                     continue
-                template.setLang(lang)
-                data = {}
-                for field_name, field in template._columns.iteritems():
-                    if getattr(field, 'translate', False) \
-                            and template[field_name] != prev_data[field_name]:
-                        data[field_name] = template[field_name]
-                if data:
-                    with Transaction().set_context(language=lang):
-                        tax_obj.write(new_id, data)
-            template.setLang(prev_lang)
-            template2tax[template.id] = new_id
-        else:
-            new_id = template2tax[template.id]
+                with Transaction().set_context(language=lang):
+                    template = self.__class__(self.id)
+                    data = {}
+                    for field_name, field in template._fields.iteritems():
+                        if (getattr(field, 'translate', False)
+                                and (getattr(template, field_name)
+                                    != prev_data[field_name])):
+                            data[field_name] = getattr(template, field_name)
+                    if data:
+                        Tax.write([new_tax], data)
+            template2tax[self.id] = new_tax.id
+        new_id = template2tax[self.id]
 
         new_childs = []
-        for child in template.childs:
-            new_childs.append(self.create_tax(child, company_id,
-                template2tax_code, template2account, template2tax=template2tax,
-                parent_id=new_id))
+        for child in self.childs:
+            new_childs.append(child.create_tax(company_id, template2tax_code,
+                    template2account, template2tax=template2tax,
+                    parent_id=new_id))
         return new_id
 
-TaxTemplate()
-
 
 class Tax(ModelSQL, ModelView):
     '''
@@ -559,9 +516,7 @@
         fixed: tax = amount
         none: tax = none
     '''
-    _name = 'account.tax'
-    _description = 'Account Tax'
-
+    __name__ = 'account.tax'
     name = fields.Char('Name', required=True, translate=True)
     description = fields.Char('Description', required=True, translate=True,
             help="The name that will be used in reports")
@@ -575,7 +530,7 @@
         '%(table)s.sequence %(order)s',
         help='Use to order the taxes')
     currency_digits = fields.Function(fields.Integer('Currency Digits',
-        on_change_with=['company']), 'get_currency_digits')
+        on_change_with=['company']), 'on_change_with_currency_digits')
     amount = fields.Numeric('Amount', digits=(16, Eval('currency_digits', 2)),
         states={
             'required': Eval('type') == 'fixed',
